
/*  ###############################################################
    ##
    ##     C Tree Builder
    ##
    ##     File:         globals.h
    ##
    ##     Programmer:   Shawn Flisakowski
    ##     Date:         Dec 16, 1994
    ##
    ##
    ###############################################################  */

#ifndef     GLOBALS_H
#define     GLOBALS_H

#include  <stdio.h>
#include  <string.h>

#include "config.h"
#include "nametbl.h"

/*  ###############################################################  */

#ifdef    DEFINE_GLOBALS

#define   EXT_DEF
#define   EXT_INIT(VarDef,Init)    VarDef = Init

#else

#define   EXT_DEF                  extern
#define   EXT_INIT(VarDef,Init)    extern VarDef

#endif

/*  ###############################################################  */

#define MAX_FILES	256

/*  ###############################################################  */

#include    "ctree.h"
#include    "heap.h"
#include    "treestk.h"

/*  ###############################################################  */

	/* To hold the files/directories requested at startup */
EXT_DEF char *file_list[MAX_FILES];

    /* The stack and top of the stack */
EXT_INIT(TreeStack *ParseStack, NULL);
EXT_INIT(Stk_Item *Parse_TOS, NULL);

    /* Parse trees for included files are put here */
EXT_INIT(TreeStack *DoneStack, NULL);

    /* The global name table. */
EXT_INIT(NameTbl *gNameTbl, NULL);

/*  ###############################################################  */

#endif  /* GLOBALS_H */
