
// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o
// o
// o     File:         heap.h
// o
// o     Programmer:   Shaun Flisakowski
// o     Date:         Apr 27, 1994
// o 
// o     Multi-heap Manager
// o
// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

#ifndef    HEAP_H
#define    HEAP_H

#include "utype.h"

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

#define    MIN_HUNK_ARRY        8
#define    DEFLT_RATIO        256

#define    min(X, Y)        ( ((X) < (Y)) ? (X) : (Y) )
#define    max(X, Y)        ( ((X) > (Y)) ? (X) : (Y) )

#define    PNTR_SZE         sizeof(void*)
#define    ALGN_SZE         sizeof(double)
#define    MIN_SIZE         max(PNTR_SZE,ALGN_SZE)

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

class Heap 
{
  public:
    uint    chnk_sze;
    uint    ch_ratio;

    uint    num_alloc;
    uint    num_free;
    uint    num_hunks;

    uint    hunk_array_sze;
    uint    next_chunk;

    void   *free_list;
    void  **hunks;

  public:
    Heap( uint chunk_size, uint chnk_hunk_ratio );
   ~Heap();

    // Get information about allocs/frees
    void info( uint *allocd, uint *freed, uint *hunks );

    // Free all chunks in this heap.
    void clear();

    void *err(int fail);

    void *alloc();
    void  free(void *chunk);
};

// o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o+o

#endif    // HEAP_H 
